<?php
/**
 * Created by gzhq.
 * User: 252378189@qq.com
 * Date: 2018/1/5
 * Time: 15:48
 */
class gzhq_game_flower extends gzhq_base{
	
    //进行浇水数据发送
    public function send_flower_js(){
        echo(__CLASS__."->".__FUNCTION__."\r\n");

        $redis_conn = $this->arr['server']->redis_pool->get();

        $mysql_conn = $this->arr['server']->mysql_pool->get();

        //查一下当前连接用户的uid
        $tmp_user_info = $this->arr['server']->get_user_by_fd($this->arr['fd']);
        if($tmp_user_info['uid']) {//如果用户登陆正常
		
			$sql = "SELECT `ff_id`,`seed_num`,`mature_time`,`grow_static` FROM ".get_table("game_flower_field")." where `uid`=".$tmp_user_info['uid'];
			$query = $mysql_conn->Query($sql);
			while($value = $mysql_conn -> FetchArray($query)) {
				if(strtotime($value['mature_time'])>time()){
					$tmp_data[] = $value;
				}
			}
			
            //获取用户花卉浇水状态
            $js_key = USER_FLOWER_WATER_KEY.$tmp_user_info['uid'];
            //加锁写数据
            //$mylock = new gzhq_lock("FileLock");
            //$mylock->getLock($js_key,5);
            $tmp_js = get_redis_info($redis_conn,$js_key);
			
			$tmp_result = array();
			if($tmp_data && $tmp_js){
				foreach($tmp_data as $n=>$m){
					foreach( $tmp_js as $k => $v ){
						if($k==$m['ff_id']){
							if($m['seed_num'] && $v==1){
								$tmp_result[$k] = $v;
							}
						}
					}
				}
			}
			
            //$mylock->unLock($js_key);
            $this->arr['server']->redis_pool->put($redis_conn);
            $this->arr['server']->mysql_pool->put($mysql_conn);
            //返回数据
			if($tmp_result){
				$tmp_send = $GLOBALS["SYS_RETURN_TMP"];
				$tmp_send['ga'] = "send_flower_js_bak";
				$tmp_send['gd'] = $tmp_result;
				$tmp_send['code'] = 1;
				$this->arr['server']->send_user($this->arr['fd'],$tmp_send);
			}
           
            return true;
        }else{
            echo("用户不在线:fd=".$this->arr['fd']."||uid=".$tmp_user_info['uid']);
        }
        $this->arr['server']->redis_pool->put($redis_conn);
        $this->arr['server']->mysql_pool->put($mysql_conn);
        return true;

    }
	
	//进行施肥数据发送
    public function send_flower_fat(){
        echo(__CLASS__."->".__FUNCTION__."\r\n");

        $redis_conn = $this->arr['server']->redis_pool->get();

        $mysql_conn = $this->arr['server']->mysql_pool->get();

        //查一下当前连接用户的uid
        $tmp_user_info = $this->arr['server']->get_user_by_fd($this->arr['fd']);
        if($tmp_user_info['uid']) {//如果用户登陆正常
			
			$sql = "SELECT `ff_id`,`ff_exp`,`fat_uid`,`fat_time`,`fat_produce`,`fat_rate` FROM ".get_table("game_flower_field")." where `uid`=".$tmp_user_info['uid'];
			$query = $mysql_conn->Query($sql);
			while($value = $mysql_conn -> FetchArray($query)) {
				if(strtotime($value['w_time'])>time()){
					$tmp_data[] = $value;
				}else{//置空没有的施肥数据
					if($value['w_uid']){
						$where = " and uid='".$tmp_user_info['uid']."' and ff_id='".$value['ff_id']."' ";
						$arr_up = array(
							'fat_uid'		=> 0,//施肥ID
							'fat_time'		=> '0000-00-00 00:00:00',//施肥时间
							'fat_produce'	=> 0,//施肥增加的产量
							'fat_rate'		=> 0,//施肥增加的产量百份
						);
						$up_rs = update_record($GLOBALS["conn"],'game_flower_field',$arr_up,'',$where);
						if(!$up_rs){
							sys_log_write_content( 'game_flower_field:'.json_encode($arr_up) ,"error_log","up_game_flower_field_sql");
							unset($arr_up,$up_rs);
						}
					}
				}
			}
			
            //获取用户花卉施肥数据
            $sf_key = USER_FLOWER_FAT_KEY.$tmp_user_info['uid'];
            //加锁写数据
            //$mylock = new gzhq_lock("FileLock");
            //$mylock->getLock($js_key,5);
            $tmp_sf = get_redis_info($redis_conn,$sf_key);
			
			$tmp_result = array();
			if($tmp_data && $tmp_sf){
				foreach($tmp_data as $n=>$m){
					foreach( $tmp_sf as $k => $v ){
						if($k==$m['ff_id']){
							$tmp_result[$k] = array(
								'ff_id'			=> $m['ff_id'],
								'fat_time'		=> strtotime($m['fat_time'])-time()>0? strtotime($m['fat_time'])-time():0,
								'fat_time_tol'	=> $v['fat_time_tol'],
								'ff_exp'		=> $m['ff_exp']
							);
						}
					}
				}
			}
			
            //$mylock->unLock($js_key);
            $this->arr['server']->redis_pool->put($redis_conn);
            $this->arr['server']->mysql_pool->put($mysql_conn);
            //返回数据
			
			$tmp_send = $GLOBALS["SYS_RETURN_TMP"];
			$tmp_send['ga'] = "send_flower_fat_bak";
			$tmp_send['gd'] = $tmp_result;
			$tmp_send['code'] = 1;
			$this->arr['server']->send_user($this->arr['fd'],$tmp_send);
			
           
            return true;
        }else{
            echo("用户不在线:fd=".$this->arr['fd']."||uid=".$tmp_user_info['uid']);
        }
        $this->arr['server']->redis_pool->put($redis_conn);
        $this->arr['server']->mysql_pool->put($mysql_conn);
        return true;

    }
	
	
}