<?php
/**
 * Created by gzhq.
 * User: 252378189@qq.com
 * Date: 2018/1/5
 * Time: 15:48
 */
class gzhq_game extends gzhq_base{


   //发送用户属性改变通知
    public function init_info(){
        $uid = $this->arr['uid'];
        echo("gzhq_game.init_info");
        $redis_conn = $this->arr['server']->redis_pool->get();
        $mysql_conn = $this->arr['server']->mysql_pool->get();

        //获取用户的属性
        $tmp_prop = get_game_user_prop($uid,$mysql_conn,$redis_conn);

        $this->arr['server']->redis_pool->put($redis_conn);
        $this->arr['server']->mysql_pool->put($mysql_conn);

        //发送属性改变的通知
        $return_arr = array(
            "ga"	=> 'init_info',
            "code"	=> 1,
            "gd"	=> array(
                'have_gold'=>round($tmp_prop['have_gold']),//'可用金币',
                'grade'=>$tmp_prop['grade'],//'等级',
                'exp'=>round($tmp_prop['exp']),//'当前等级经验',
                'upgrade_exp'=>round($GLOBALS["SYS_FLOWER_MEMBER_2"][$tmp_prop['grade']]['next_exp'])//'升级经验'
            )
        );
        $this->arr['server']->send_user($this->arr['fd'],$return_arr);

        return true;
    }


    //发送用户升级通知
    public function send_user_grade_up(){

        //发送属性改变的通知
        $return_arr = array(
            "ga"	=> 'send_user_grade_up',
            "code"	=> 1,
            "gd"	=> $this->arr['d']
        );

        echo("用户等级升了");
        var_dump($return_arr);

        $this->arr['server']->send_user($this->arr['fd'],$return_arr);
        return true;
    }


    //进行数据发送(这是一个例子)
    public function send_data(){
        echo(__CLASS__."->".__FUNCTION__."\r\n");

        $redis_conn = $this->arr['server']->redis_pool->get();

        //$mysql_conn = $this->arr['server']->mysql_pool->get();

        //查一下当前连接用户的uid
        $tmp_user_info = $this->arr['server']->get_user_by_fd($this->arr['fd']);
        if($tmp_user_info['uid']) {//如果用户登陆正常
            //获取会员当前局的数据
            $room_key = USER_ROOM_KEY.$tmp_user_info['uid'];
            //加锁写数据
            $mylock = new gzhq_lock("FileLock");
            $mylock->getLock($room_key,5);
            $tmp_data = get_redis_info($redis_conn,USER_ROOM_KEY.$room_key,TOKEN_KEY_TIME);
            if($tmp_data){//如果已经有数据
                $tmp_data['add_bs'] +=10;
                set_redis_info($redis_conn,USER_ROOM_KEY.$room_key,$tmp_data);
            }else{//如果还没有数据
                $tmp_data['add_bs'] =10;
                set_redis_info($redis_conn,USER_ROOM_KEY.$room_key,$tmp_data);
            }
            $mylock->unLock($room_key);
            $this->arr['server']->redis_pool->put($redis_conn);
            //返回数据
            $tmp_send = $GLOBALS["SYS_RETURN_TMP"];
            $tmp_send['ga']="send_data_bak";
            $tmp_send['d'] = array(
                'msg'=>'保存数据成功'.$tmp_data['add_bs']
            );
            $tmp_send['code'] = 1;
            $this->arr['server']->send_user($this->arr['fd'],$tmp_send);
            return true;
        }else{
            echo("用户不在线:fd=".$this->arr['fd']."||uid=".$tmp_user_info['uid']);
        }
        $this->arr['server']->redis_pool->put($redis_conn);
        return true;

    }

}